import java.util.*;

public class LinkSimulation {
    public static void main(String [] args) {
	// default parameters
	double lambda = 1.0;	// 1 packet per second
	double rate = 1000000; 	// 1Mbytes/second
	double delay = 0.1; 	// 100 milliseconds
	int n = 100;		// 100 packets
	int qsize = 100; 	// TX queue size for link

	try {
	    for(int i = 0; i < args.length; ++i) {
		if (args[i].startsWith("lambda=")) 
		    lambda = Double.parseDouble(args[i].substring(7));
		else if (args[i].startsWith("rate=")) 
		    rate = Double.parseDouble(args[i].substring(5));
		else if (args[i].startsWith("latency=")) 
		    delay = Double.parseDouble(args[i].substring(8));
		else if (args[i].startsWith("delay=")) 
		    delay = Double.parseDouble(args[i].substring(6));
		else if (args[i].startsWith("qsize=")) 
		    qsize = Integer.parseInt(args[i].substring(6));
		else if (args[i].startsWith("n=")) 
		    n = Integer.parseInt(args[i].substring(2));
		else
		    throw new Exception("unknown option: " + args[i]);
	    }
	} catch (Exception ex) {
	    System.err.println(ex);
	    System.err.println("usage: Link [lambda=<double>] [rate=<double>] [delay=<double>] [n=<int>] [qsize=<int>]");
	    System.exit(1);
	}


	Receiver receiver = new Receiver();
	Link link = new Link(rate, delay, qsize);
	link.connect(receiver);
	Sender sender = new Sender(n, lambda, link);

	Simulation.schedule_event(0.0, sender);
	Simulation.run();
    }
}
	
