import java.util.Random;

public class Sender implements Event {
    double lambda;
    Link link;
    int count;
    int max_count;
    Random rnd;

    public Sender(int c, double l, Link lnk) {
	count = 1;
	max_count = c;
	lambda = l;
	link = lnk;
	rnd = new Random();
    }

    private double exp_random(double lambda) {
	return  Math.log(1 - rnd.nextDouble())/(-lambda);
    }

    static Packet new_packet(int seq_number) {
	// change this behavior here
	return new Packet(1500, seq_number);
    }

    public void process() {	// action for "wake up" event
	if (count <= max_count) {
	    Packet p = new_packet(count);
	    link.send(p);
	    Simulation.schedule_event(exp_random(lambda), this);
	    System.out.println("Sender: " + count
			       + ": time=" + Simulation.time()
			       + ": packet " + p.data());
	    count += 1;
	} else {
	    System.out.println("Sender: terminated.");
	}
    }
}
